#ifndef __MATRIX_H__
#define __MATRIX_H__

typedef struct
{
  int nnz;
  int n_rows;
  int n_cols;

  double *val;
  int *col_ind;
  int *row_ptr_begin;
  int *row_ptr_end;
}
Matrix;

Matrix *matrix_new                   (const int n_rows,
                                      const int n_cols,
                                      const int nnz);
void    matrix_free                  (Matrix *M);
void    matrix_dump_nonzeros         (Matrix *A);
Matrix *matrix_load_matrix_market    (const char *filename);

#endif /* __MATRIX_H__ */
